Redmine - Defect #32774

Creating time tracking entry for other user through rest API fails with 403
2020-01-08 14:07 - Valdir Stiebe Junior

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Time tracking Estimated time: 0.00 hour
Target version: 411

Resolution: Fixed Affected version: 4.1.0
Description

Trying to create a time tracking entry for another user through rest AP| with admin user without a role not a member on the project.
I'm getting a forbidden 403 return.
Maybe this is related to #3848.

However, through the user interface it works ok.
I've created an workaround for my scripts with the following patch.

-—— app/controllers/timelog_controller.rb
+++ app/controllers/timelog_controller.rb
@@ -256,16 +256,13 @@
render_403
return false
end
end

def authorize_logging_time_for_other_users
. if !'User.current.allowed_to?(:log_time_for_other_users, @project) && params['time_entry'].pre
sent? && params|'time_entry']['user_id'].present? && params['time_entry']['user_id'].to_1 != User.
current.id
. render_error :message => 1 (:error_not_allowed_to_log_time_for_other_users), :status => 403
= return false
= end
+ return true

end

def find_time_entries
@time_entries = TimeEntry.where(:id => params([:1id] || params[:ids]).
preload(:project => :time_entry_activities).
preload(:user) .to_a

Related issues:
Related to Redmine - Feature #3848: Permission to log time for another user Closed 2009-09-11

Associated revisions

Revision 19669 - 2020-04-05 16:23 - Jean-Philippe Lang
Creating time tracking entry for other user through rest API fails with 403 (#32774).

Patch by Marius BALTEANU.

Revision 19670 - 2020-04-05 16:28 - Jean-Philippe Lang
Creating time tracking entry for other user through rest API fails with 403 (#32774).

Revision 19675 - 2020-04-05 19:29 - Jean-Philippe Lang
Reverted r19669 and r19670 (#32774).

Revision 19676 - 2020-04-05 20:39 - Jean-Philippe Lang
Creating time tracking entry for other user through rest API fails with 403 (#32774).
https://www.redmine.org/issues/3848

Revision 19677 - 2020-04-05 21:24 - Jean-Philippe Lang
Set time entry author in controller (#32774).

Revision 19678 - 2020-04-05 21:28 - Jean-Philippe Lang

Don't use User.current in TimeEntrylmport model but #user instead (#32774).

Revision 19679 - 2020-04-06 12:02 - Jean-Philippe Lang
Merged r19676 to r19678 to 4.1-stable (#32774).

History

#1 - 2020-01-12 22:51 - Marius BALTEANU
- Related to Feature #6486: Log time for other users added

#2 - 2020-01-12 22:52 - Marius BALTEANU
- Related to deleted (Feature #6486: Log time for other users)

#3 - 2020-01-12 22:52 - Marius BALTEANU

- Related to Feature #3848: Permission to log time for another user added

#4 - 2020-01-12 23:08 - Marius BALTEANU
- Status changed from New to Confirmed
- Assignee set to Marius BALTEANU

- Target version set to 4.1.1

#5 - 2020-01-12 23:51 - Marius BALTEANU
- File 0001-Fix-creating-time-tracking-entry-through-rest-API-do.patch added
- Assignee deleted (Marius BALTEANU)

authorize_logging_time_for_other_users returns false because @project is not set yet. Both methods find_optional_issue and find_optional_project
from TimelogController expects :issue_id and :project_id only as root params, not nested params (inside :time_entry).

The fix strictly for this case was to override method find_optional_project in order to accept also params[:time_entry][:project_id]. All tests pass.

Jean-Philippe, could your review the fix, please? Also, we should do the same change for find_optional_issue as well?
Valdir Stiebe Junior, thanks for detecting and reporting the issue. Could you try the fix from the patch?

#6 - 2020-01-12 23:52 - Marius BALTEANU
- Subject changed from Creating time tracking entry through rest APl doesn't behaviour like the user interface to Creating time tracking entry for other

user through rest API doesn't work

#7 - 2020-01-13 18:34 - Valdir Stiebe Junior

Valdir Stiebe Junior, thanks for detecting and reporting the issue. Could you try the fix from the patch?

It works for us. Thank you!

#8 - 2020-02-27 02:13 - Go MAEDA
- Assignee set to Jean-Philippe Lang

#9 - 2020-04-05 16:29 - Jean-Philippe Lang

- Subject changed from Creating time tracking entry for other user through rest APl doesn't work to Creating time tracking entry for other user through
rest API fails with 403

- Status changed from Confirmed to Resolved

- Resolution set to Fixed

Committed, thanks.
https://gitlab.com/redmine-org/redmine/pipelines/108752345

Marius BALTEANU wrote:

Also, we should do the same change for find_optional_issue as well?

Good point, I've fixed find_optional_issue in r19670.

#10 - 2020-04-05 19:33 - Jean-Philippe Lang
- Status changed from Resolved to New

- Resolution deleted (Fixed)

I've reverted the change and will work on another fix.
We should not respond with 403 when submitting the form at /time_entries/new with an project or issue that is not OK.

#11 - 2020-04-05 20:15 - Marius BALTEANU
Jean-Philippe Lang wrote:
I've reverted the change and will work on another fix.

We should not respond with 403 when submitting the form at /time_entries/new with an project or issue that is not OK.

Ok, please let me know if you need my help on this.

#12 - 2020-04-06 12:47 - Jean-Philippe Lang
- Status changed from New to Closed

- Resolution set to Fixed

Fix committed.

#13 - 2020-04-06 12:51 - Marius BALTEANU

Jean-Philippe Lang wrote:

Fix committed.

Thanks Jean-Philippe for fixing this issue, it seems that I've added some bad lines of code. I'll add in the following weeks a patch to remove the
method set_author_if_nil from TimeEntry model.

Files

0001-Fix-creating-time-tracking-entry-through-rest-API-do.patch 2.32 KB 2020-01-12 Marius BALTEANU
